<?php
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is http://www.sa-mods.info
 *
 * The Initial Developer of the Original Code is
 * wayne Mankertz.
 * Portions created by the Initial Developer are Copyright (C) 2008-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */
if (!defined('SMF'))
	die('Hacking attempt...');

function aff_array_insert(&$input, $key, $insert, $where = 'before', $strict = false)
{
	$position = array_search($key, array_keys($input), $strict);
	
	// Key not found -> insert as last
	if ($position === false)
	{
		$input = array_merge($input, $insert);
		return;
	}
	
	if ($where === 'after')
		$position += 1;

	// Insert as first
	if ($position === 0)
		$input = array_merge($insert, $input);
	else
		$input = array_merge(
			array_slice($input, 0, $position),
			$insert,
			array_slice($input, $position)
		);
}
function Affiliate_actions(&$actionArray)
{
    $actionArray['affiliates'] = array('Affiliates.php', 'affiliates');
}

function Affiliate_core_features(&$core_features)
{
	$core_features['affiliate'] = array(
		'url' => 'action=admin;area=affiliates',
		'settings' => array(
			'enable_affiliates' => 1,
		),
	);
}

function Affiliate_load_permissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{
	global $context;
	
	$permissionList['membergroup'] += array(
		'view_affiliates' => array(false, 'affiliates', 'affiliates'),
			'add_affiliates' => array(false, 'affiliates', 'affiliates'),
			'affiliates_auto_approve' => array(false, 'affiliates', 'affiliates'),
			'rate_affiliates' => array(false, 'affiliates', 'affiliates'),
			'edit_afflinks' => array(false, 'affiliates', 'affiliates'),
			'edit_afflinks_any' => array(false, 'affiliates', 'affiliates'),
			'delete_afflinks_any' => array(false, 'affiliates', 'affiliates'),
			'unapprove_afflinks' => array(false, 'affiliates', 'affiliates'),
			'approve_affiliates' => array(false, 'affiliates', 'affiliates'),
			'report_affiliates' => array(false, 'affiliates', 'affiliates'),
			'veiwreport_affiliates' => array(false, 'affiliates', 'affiliates'),
	);
	
	$context['non_guest_permissions'] = array_merge(
		$context['non_guest_permissions'],
		array(
		'affiliates_auto_approve',
		'edit_afflinks',
		'edit_afflinks_any',
		'delete_afflinks_any',
		'unapprove_afflinks',
		'approve_affiliates',
		'report_affiliates',
		'veiwreport_affiliates',
		)
	);
}

function Affiliate_menu_buttons(&$menu_buttons)
{
	global $context, $modSettings, $scripturl, $txt;
	
	$context['allow_aff'] = allowedTo('view_affiliates');
	if(!empty($modSettings['enable_affiliates'])){
	aff_array_insert($menu_buttons, 'search',
		array(
			'affiliates' => array(
				'title' => $txt['saAffiliates'],
				'href' => $scripturl . '?action=affiliates',
				'show' => $context['allow_aff'],
				'sub_buttons' => array(
				),
				'active_button' => false,
			),
		)
	);
	}
}

function Affiliate_admin_areas(&$admin_areas)
{
	global $context, $modSettings, $scripturl, $txt;
	
	aff_array_insert($admin_areas, 'layout',
		array(
			
			'affiliates' => array(
				'title' => $txt['Affiliates'],
				'permission' => array('admin_forum'),
				'areas' => array(
					'affiliates' => array(
						'label' => $txt['Affiliates'],
						'file' => 'Affiliates_Admin.php',
					'function' => 'affiliates_admin',
						'enabled' => !empty($modSettings['enable_affiliates']),
						'permission' => array('admin_forum'),
						'subsections' => array(
							'version' => array('Version/Credits'),
						'config' => array($txt['affiliatesconfig']),
						'affiliates' => array($txt['affiliatesad']),
						'add' => array($txt['AddAffiliates']),
						//'affiliatesalist' => array($txt['ApproveAffiliates']),
						'affiliatesyb' => array($txt['YourBanners']),
						),
					),
			
		),
	),
	)
	);
}

?>